#!/usr/bin/python
""" 
	xrpm - version 2.02
		module ftputil.py
		
    Copyright (C) 1997  George A. Farris
		george@gmsys.com - www.gmsys.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""

import os
from ftplib import FTP
from Tkinter import *
from Dialog import *

###############################################################################
#
# Do all the operations involved with ftp sites
# Methods: read, readlines, open, dir, pwd, cd, get, close, store
#
#------------------------------------------------------------------------------
class ftpsites:

	def read(self, file):
		fd = open(file, 'r')
		list = fd.read()
		return list
	
	def readlines(self, file):
		fd = open(file, 'r')
		list = fd.readlines()
		return list

	def store(self):
		return 'ok'
		
	def open(self, site, uid, passwd):
		s = FTP(site)
		if uid:
			s.login(uid, passwd)
		else:
			s.login()
		return s
	
#************************************************************************************
# Save an FTP site into the .ftpsites file.
# saveFtpSite(event)
#		- "event" event from double click in file box.
#------------------------------------------------------------------------------------
	def saveFtpSite(self):

		# here we open our own ".ftp-sites" file
		homeDir = os.environ['HOME']
		try:
			fdi = open(homeDir+'/.ftp-sites', 'r')	# Get our stored ftp list
		except:
			d = Dialog(None, {'title': 'File Error!',
					'text':
					'Your .ftp-sites file is missing!'
					' You may need to create it.  You should copy'
					' the system ftp-sites file and modify it.'
					' You can find it in the system install directory,'
					' normally "/usr/lib/xrpm".',
					'bitmap': DIALOG_ICON,
					'default': 0,
					'strings': ('Dismiss',)})
			return
																
		newfile = []
		for i in fdi.readlines():		# read the file in to "list"
			newfile.append(i)
		fdi.close()
		
		fdo = open(homeDir+'/.ftp-sites', 'w')
		
		for j in newfile:
			fdo.write(j)

		fdo.write(self.connected_site+' '+self.ftpdir+'\n')
		fdo.close()
		self.counter.config(text='                        Site is Saved ')

#------------------------------------------------------------------------------
def test():

	ftplist = ftpsites()
	site = ftplist.open('localhost')
	site.dir()
		
if __name__ == '__main__': test()
